Index: /palm/trunk/SOURCE/virtual_measurement_mod.f90
===================================================================
--- /palm/trunk/SOURCE/virtual_measurement_mod.f90	(revision 4399)
+++ /palm/trunk/SOURCE/virtual_measurement_mod.f90	(revision 4400)
@@ -602,58 +992,39 @@
              ENDDO
              len_char = len_char - 1
-!
-!--          Now, compare the measured variable with the list of allowed 
-!--          variables. 
-             DO  lll= 1, SIZE( list_allowed_variables )
-                IF ( measured_variables_file(ll)(1:len_char) ==                &
-                     TRIM( list_allowed_variables(lll) ) )  THEN
-                   vmea(l)%nmeas = vmea(l)%nmeas + 1
-                   measured_variables(vmea(l)%nmeas) =                         &
+
+             measured_variables(vmea(l)%nmeas) =                               &
                                        measured_variables_file(ll)(1:len_char)
-                ENDIF
-             ENDDO
+             vmea(l)%nmeas = vmea(l)%nmeas + 1
+
           ENDIF
        ENDDO
-       
-       
-!
-!--    Allocate array for the measured variables names for the respective site.
-       ALLOCATE( vmea(l)%measured_vars_name(1:vmea(l)%nmeas) )
-
+       vmea(l)%nmeas = vmea(l)%nmeas - 1
+!
+!--    Allocate data-type array for the measured variables names and attributes
+!--    at the respective site.
+       ALLOCATE( vmea(l)%var_atts(1:vmea(l)%nmeas) )
+!
+!--    Store the variable names in a data structures, which assigns further 
+!--    attributes to this name. Further, for data output reasons, create a 
+!--    string of output variables, which will be written into the attribute
+!--    data_content.
        DO  ll = 1, vmea(l)%nmeas
-          vmea(l)%measured_vars_name(ll) = TRIM( measured_variables(ll) )
+          vmea(l)%var_atts(ll)%name = TRIM( measured_variables(ll) )
+
+          vmea(l)%data_content = TRIM( vmea(l)%data_content ) // " " //        &
+                                 TRIM( vmea(l)%var_atts(ll)%name )
        ENDDO
 !
-!--    In case of chemistry, check if species is considered in the modelled
-!--    chemistry mechanism.
-!        IF ( air_chemistry )  THEN
-!           DO  ll = 1, vmea(l)%nmeas
-!              chem_include = .FALSE.
-!              DO  n = 1, nvar
-!                 IF ( TRIM( vmea(l)%measured_vars_name(ll) ) ==                 &
-!                      TRIM( chem_species(n)%name ) )  chem_include = .TRUE.
-!              ENDDO
-! !
-! !--  Revise this. It should only check for chemistry variables and not for all!
-!              IF ( .NOT. chem_include )  THEN
-!                 message_string = TRIM( vmea(l)%measured_vars_name(ll) ) //     &
-!                                  ' is not considered in the modelled '  //     &
-!                                  'chemistry mechanism'
-!                 CALL message( 'vm_init', 'PA0000', 0, 0, 0, 6, 0 )
-!              ENDIF
-!           ENDDO
-!        ENDIF
-!
-!--    Read the UTM coordinates for the actual site. Based on the coordinates,
+!--    Read all the UTM coordinates for the site. Based on the coordinates,
 !--    define the grid-index space on each subdomain where virtual measurements
-!--    should be taken. Note, the entire coordinate arrays will not be stored 
-!--    as this would exceed memory requirements, particularly for trajectory 
-!--    measurements. 
+!--    should be taken. Note, the entire coordinate array (on the entire model
+!--    domain) won't be stored as this would exceed memory requirements, 
+!--    particularly for trajectories.
        IF ( vmea(l)%nmeas > 0 )  THEN
 !
-!--       For stationary measurements UTM coordinates are just one value and 
-!--       its dimension is "station", while for mobile measurements UTM 
+!--       For stationary measurements UTM coordinates are just one value and
+!--       its dimension is "station", while for mobile measurements UTM
 !--       coordinates are arrays depending on the number of trajectories and
-!--       time, according to (UC)2 standard. First, inquire dimension length 
+!--       time, according to (UC)2 standard. First, inquire dimension length
 !--       of the UTM coordinates.
           IF ( vmea(l)%trajectory )  THEN
@@ -661,78 +1032,110 @@
 !--          For non-stationary measurements read the number of trajectories
 !--          and the number of time coordinates.
-             CALL get_dimension_length( vmea_general%id_vm,                    &
-                                        vmea(l)%ntraj,                         &
-                                        "traj" //                              &
-                                        TRIM( dum ) )
-             CALL get_dimension_length( vmea_general%id_vm,                    &
+             CALL get_dimension_length( pids_id,                               &
+                                        vmea(l)%n_tr_st,                       &
+                                        "traj" // TRIM( dum ) )
+             CALL get_dimension_length( pids_id,                               &
                                         dim_ntime,                             &
-                                        "ntime" //                             &
-                                        TRIM( dum ) )
-!
-!--       For stationary measurements the dimension for UTM and time 
-!--       coordinates is 1. 
+                                        "ntime" // TRIM( dum ) )
+!
+!--       For stationary measurements the dimension for UTM is station
+!--       and for the time-coordinate it is one.
           ELSE
-             vmea(l)%ntraj  = 1
+             CALL get_dimension_length( pids_id,                               &
+                                        vmea(l)%n_tr_st,                       &
+                                        "station" // TRIM( dum ) )
              dim_ntime = 1
           ENDIF
 !
-!-        Allocate array which defines individual time frame for each 
+!-        Allocate array which defines individual time/space frame for each
 !--       trajectory or station.
-          ALLOCATE( vmea(l)%dim_t(1:vmea(l)%ntraj) )
-!
-!--       Allocate temporary arrays for UTM and height coordinates. Note, 
+          ALLOCATE( vmea(l)%dim_t(1:vmea(l)%n_tr_st) )
+!
+!--       Allocate temporary arrays for UTM and height coordinates. Note,
 !--       on file UTM coordinates might be 1D or 2D variables
-          ALLOCATE( e_utm(1:vmea(l)%ntraj,1:dim_ntime) )
-          ALLOCATE( n_utm(1:vmea(l)%ntraj,1:dim_ntime) )
-          ALLOCATE( z_ag(1:vmea(l)%ntraj,1:dim_ntime)  )
-          
-          ALLOCATE( e_utm_tmp(1:vmea(l)%ntraj,1:dim_ntime) )
-          ALLOCATE( n_utm_tmp(1:vmea(l)%ntraj,1:dim_ntime) )
-!
-!--       Read _FillValue attributes of the coordinate dimensions.
-          CALL netcdf_data_input_att( fill_eutm, char_fillvalue,               &
-                                      vmea_general%id_vm, '',                  &
-                                      .NOT. global_attribute, '',              &
-                                      char_eutm // TRIM( dum ) )
-          CALL netcdf_data_input_att( fill_nutm, char_fillvalue,               &
-                                      vmea_general%id_vm, '',                  &
-                                      .NOT. global_attribute, '',              &
-                                      char_nutm // TRIM( dum ) )
-          CALL netcdf_data_input_att( fill_zag, char_fillvalue,                &
-                                      vmea_general%id_vm, '',                  &
-                                      .NOT. global_attribute, '',              &
-                                      char_zag  // TRIM( dum ) )
-!
-!--       Read UTM and height coordinates coordinates for all trajectories and 
-!--       times. 
+          ALLOCATE( e_utm(1:vmea(l)%n_tr_st,1:dim_ntime)       )
+          ALLOCATE( n_utm(1:vmea(l)%n_tr_st,1:dim_ntime)       )
+          ALLOCATE( station_h(1:vmea(l)%n_tr_st,1:dim_ntime)   )
+          ALLOCATE( zar(1:vmea(l)%n_tr_st,1:dim_ntime)         )
+          e_utm     = 0.0_wp
+          n_utm     = 0.0_wp
+          station_h = 0.0_wp
+          zar       = 0.0_wp
+
+          ALLOCATE( e_utm_tmp(1:vmea(l)%n_tr_st,1:dim_ntime) )
+          ALLOCATE( n_utm_tmp(1:vmea(l)%n_tr_st,1:dim_ntime) )
+!
+!--       Read UTM and height coordinates coordinates for all trajectories and
+!--       times. Note, in case these obtain any missing values, replace them
+!--       with default _FillValues.
+          CALL inquire_fill_value( pids_id,                                    &
+                                   char_eutm // TRIM( dum ),                   &
+                                   nofill,                                     &
+                                   fill_eutm )
+          CALL inquire_fill_value( pids_id,                                    &
+                                   char_nutm // TRIM( dum ),                   &
+                                   nofill,                                     &
+                                   fill_nutm )
+          CALL inquire_fill_value( pids_id,                                    &
+                                   char_zar // TRIM( dum ),                    &
+                                   nofill,                                     &
+                                   fill_zar )
+!
+!--       Further line is just to avoid compiler warnings. nofill might be used
+!--       in future.
+          IF ( nofill == 0  .OR.  nofill /= 0 )  CONTINUE
+!
+!--       Read observation coordinates. Please note, for trajectories the
+!--       observation height is stored directly in z, while for timeSeries
+!--       it is stored in z - station_h, according to UC2-standard.
           IF ( vmea(l)%trajectory )  THEN
-             CALL netcdf_data_input_var( e_utm, char_eutm // TRIM( dum ),      &
-                                         vmea_general%id_vm,                   &
-                                         0, dim_ntime-1, 0, vmea(l)%ntraj-1 )
-             CALL netcdf_data_input_var( n_utm, char_nutm // TRIM( dum ),      &
-                                         vmea_general%id_vm,                   &
-                                         0, dim_ntime-1, 0, vmea(l)%ntraj-1 )
-             CALL netcdf_data_input_var( z_ag, char_zag // TRIM( dum ),        &
-                                         vmea_general%id_vm,                   &
-                                         0, dim_ntime-1, 0, vmea(l)%ntraj-1 )
+             CALL get_variable( pids_id,                                       &
+                                char_eutm // TRIM( dum ),                      &
+                                e_utm,                                         &
+                                0, dim_ntime-1,                                &
+                                0, vmea(l)%n_tr_st-1 )
+             CALL get_variable( pids_id,                                       &
+                                char_nutm // TRIM( dum ),                      &
+                                n_utm,                                         &
+                                0, dim_ntime-1,                                &
+                                0, vmea(l)%n_tr_st-1 )
+             CALL get_variable( pids_id,                                       &
+                                char_zar // TRIM( dum ),                       &
+                                zar,                                           &
+                                0, dim_ntime-1,                                &
+                                0, vmea(l)%n_tr_st-1 )
           ELSE
-             CALL netcdf_data_input_var( e_utm(1,:), char_eutm // TRIM( dum ), &
-                                         vmea_general%id_vm )
-             CALL netcdf_data_input_var( n_utm(1,:), char_nutm // TRIM( dum ), &
-                                         vmea_general%id_vm )
-             CALL netcdf_data_input_var( z_ag(1,:),  char_zag  // TRIM( dum ), &
-                                         vmea_general%id_vm )
-          ENDIF         
+             CALL get_variable( pids_id,                                       &
+                                char_eutm // TRIM( dum ),                      &
+                                e_utm(:,1) )
+             CALL get_variable( pids_id,                                       &
+                                char_nutm // TRIM( dum ),                      &
+                                n_utm(:,1) )
+             CALL get_variable( pids_id,                                       &
+                                char_station_h // TRIM( dum ),                 &
+                                station_h(:,1) )
+             CALL get_variable( pids_id,                                       &
+                                char_zar // TRIM( dum ),                       &
+                                zar(:,1) )
+          ENDIF
+
+          e_utm = MERGE( e_utm, vmea(l)%fillout, e_utm /= fill_eutm )
+          n_utm = MERGE( n_utm, vmea(l)%fillout, n_utm /= fill_nutm )
+          zar   = MERGE( zar,   vmea(l)%fillout, zar   /= fill_zar  )
+!
+!--       Compute observation height above ground.
+          zar  = zar - station_h
 !
 !--       Based on UTM coordinates, check if the measurement station or parts
-!--       of the trajectory is on subdomain. This case, setup grid index space
-!--       sample these quantities. 
+!--       of the trajectory are on subdomain. This case, setup grid index space
+!--       sample these quantities.
           meas_flag = 0
-          DO  t = 1, vmea(l)%ntraj
-!             
-!--          First, compute relative x- and y-coordinates with respect to the 
-!--          lower-left origin of the model domain, which is the difference 
+          DO  t = 1, vmea(l)%n_tr_st
+!
+!--          First, compute relative x- and y-coordinates with respect to the
+!--          lower-left origin of the model domain, which is the difference
 !--          between UTM coordinates. Note, if the origin is not correct, the
-!--          virtual sites will be misplaced. 
+!--          virtual sites will be misplaced. Further, in case of an rotated
+!--          model domain, the UTM coordinates must be also rotated.
              e_utm_tmp(t,1:dim_ntime) = e_utm(t,1:dim_ntime) - init_model%origin_x
              n_utm_tmp(t,1:dim_ntime) = n_utm(t,1:dim_ntime) - init_model%origin_y
@@ -749,21 +1152,31 @@
 !--          trajectory. This is required as several stations and trajectories
 !--          are merged into one file but they do not have the same number of
-!--          points in time, hence, missing values may occur and cannot be 
+!--          points in time, hence, missing values may occur and cannot be
 !--          processed further. This is actually a work-around for the specific
-!--          (UC)2 dataset, but it won't harm in anyway. 
+!--          (UC)2 dataset, but it won't harm anyway.
              vmea(l)%dim_t(t) = 0
              DO  n = 1, dim_ntime
                 IF ( e_utm(t,n) /= fill_eutm  .AND.                            &
                      n_utm(t,n) /= fill_nutm  .AND.                            &
-                     z_ag(t,n)  /= fill_zag )  vmea(l)%dim_t(t) = n
+                     zar(t,n)   /= fill_zar )  vmea(l)%dim_t(t) = n
              ENDDO
 !
 !--          Compute grid indices relative to origin and check if these are
-!--          on the subdomain. Note, virtual measurements will be taken also 
-!--          at grid points surrounding the station, hence, check also for 
+!--          on the subdomain. Note, virtual measurements will be taken also
+!--          at grid points surrounding the station, hence, check also for
 !--          these grid points.
+!--          The number of surrounding grid points is set according to the
+!--          featureType.
+             IF ( vmea(l)%timseries_profile )  THEN
+                off = off_pr
+             ELSEIF ( vmea(l)%timseries     )  THEN
+                off = off_ts
+             ELSEIF ( vmea(l)%trajectory    )  THEN
+                off = off_tr
+             ENDIF
+
              DO  n = 1, vmea(l)%dim_t(t)
                 is = INT( ( e_utm(t,n) + 0.5_wp * dx ) * ddx, KIND = iwp )
-                js = INT( ( n_utm(t,n) + 0.5_wp * dy ) * ddy, KIND = iwp )             
+                js = INT( ( n_utm(t,n) + 0.5_wp * dy ) * ddy, KIND = iwp )
 !
 !--             Is the observation point on subdomain?
@@ -777,19 +1190,19 @@
 !--                height.
                    ksurf = topo_top_ind(js,is,0)
-                   ks = MINLOC( ABS( zu - zw(ksurf) - z_ag(t,n) ), DIM = 1 ) - 1
+                   ks = MINLOC( ABS( zu - zw(ksurf) - zar(t,n) ), DIM = 1 ) - 1
 !
 !--                Set mask array at the observation coordinates. Also, flag the
 !--                surrounding coordinate points, but first check whether the
-!--                surrounding coordinate points are on the subdomain. 
-                   kl = MERGE( ks-1, ks, ks-1 >= nzb  .AND. ks-1 >= ksurf )
-                   ku = MERGE( ks+1, ks, ks+1 < nzt+1 )
-                 
-                   DO  i = is-1, is+1
-                      DO  j = js-1, js+1
+!--                surrounding coordinate points are on the subdomain.
+                   kl = MERGE( ks-off, ksurf, ks-off >= nzb  .AND. ks-off >= ksurf )
+                   ku = MERGE( ks+off, nzt,   ks+off < nzt+1 )
+
+                   DO  i = is-off, is+off
+                      DO  j = js-off, js+off
                          DO  k = kl, ku
-                            meas_flag(k,j,i) = MERGE(                              &
-                                             IBSET( meas_flag(k,j,i), 0 ),         &
-                                             0,                                    &
-                                             BTEST( wall_flags_total_0(k,j,i), 0 ) &
+                            meas_flag(k,j,i) = MERGE(                           &
+                                          IBSET( meas_flag(k,j,i), 0 ),         &
+                                          0,                                    &
+                                          BTEST( wall_flags_total_0(k,j,i), 0 ) &
                                                     )
                          ENDDO
@@ -798,14 +1211,14 @@
                 ENDIF
              ENDDO
-             
+
           ENDDO
 !
-!--       Based on the flag array count the number of of sampling coordinates.
-!--       Please note, sampling coordinates in atmosphere and soil may be 
-!--       different, as within the soil all levels will be measured.           
+!--       Based on the flag array count the number of sampling coordinates.
+!--       Please note, sampling coordinates in atmosphere and soil may be
+!--       different, as within the soil all levels will be measured.
 !--       Hence, count individually. Start with atmoshere.
           ns = 0
-          DO  i = nxl-1, nxr+1
-             DO  j = nys-1, nyn+1
+          DO  i = nxl-off, nxr+off
+             DO  j = nys-off, nyn+off
                 DO  k = nzb, nzt+1
                    ns = ns + MERGE( 1, 0, BTEST( meas_flag(k,j,i), 0 ) )
@@ -813,20 +1226,20 @@
              ENDDO
           ENDDO
-          
+
 !
 !--       Store number of observation points on subdomain and allocate index
 !--       arrays as well as array containing height information.
           vmea(l)%ns = ns
-          
+
           ALLOCATE( vmea(l)%i(1:vmea(l)%ns) )
           ALLOCATE( vmea(l)%j(1:vmea(l)%ns) )
           ALLOCATE( vmea(l)%k(1:vmea(l)%ns) )
-          ALLOCATE( vmea(l)%z_ag(1:vmea(l)%ns) )      
-!
-!--       Based on the flag array store the grid indices which correspond to 
-!--       the observation coordinates. 
+          ALLOCATE( vmea(l)%zar(1:vmea(l)%ns) )
+!
+!--       Based on the flag array store the grid indices which correspond to
+!--       the observation coordinates.
           ns = 0
-          DO  i = nxl-1, nxr+1
-             DO  j = nys-1, nyn+1
+          DO  i = nxl-off, nxr+off
+             DO  j = nys-off, nyn+off
                 DO  k = nzb, nzt+1
                    IF ( BTEST( meas_flag(k,j,i), 0 ) )  THEN
@@ -835,5 +1248,5 @@
                       vmea(l)%j(ns) = j
                       vmea(l)%k(ns) = k
-                      vmea(l)%z_ag(ns)  = zu(k) - zw(topo_top_ind(j,i,0))
+                      vmea(l)%zar(ns)  = zu(k) - zw(topo_top_ind(j,i,0))
                    ENDIF
                 ENDDO
@@ -841,6 +1254,8 @@
           ENDDO
 !
-!--       Same for the soil. Based on the flag array, count the number of 
-!--       sampling coordinates in soil. Sample at all soil levels in this case. 
+!--       Same for the soil. Based on the flag array, count the number of
+!--       sampling coordinates in soil. Sample at all soil levels in this case.
+!--       Please note, soil variables can only be sampled on subdomains, not
+!--       on ghost layers.
           IF ( vmea(l)%soil_sampling )  THEN
              DO  i = nxl, nxr
@@ -850,17 +1265,17 @@
                            surf_lsm_h%end_index(j,i) )  THEN
                          vmea(l)%ns_soil = vmea(l)%ns_soil +                   &
-                                                      nzt_soil - nzb_soil + 1 
+                                                      nzt_soil - nzb_soil + 1
                       ENDIF
                       IF ( surf_usm_h%start_index(j,i) <=                      &
                            surf_usm_h%end_index(j,i) )  THEN
                          vmea(l)%ns_soil = vmea(l)%ns_soil +                   &
-                                                      nzt_wall - nzb_wall + 1 
+                                                      nzt_wall - nzb_wall + 1
                       ENDIF
                    ENDIF
                 ENDDO
              ENDDO
-          ENDIF         
-!
-!--       Allocate index arrays as well as array containing height information 
+          ENDIF
+!
+!--       Allocate index arrays as well as array containing height information
 !--       for soil.
           IF ( vmea(l)%soil_sampling )  THEN
@@ -868,6 +1283,6 @@
              ALLOCATE( vmea(l)%j_soil(1:vmea(l)%ns_soil) )
              ALLOCATE( vmea(l)%k_soil(1:vmea(l)%ns_soil) )
-             ALLOCATE( vmea(l)%depth(1:vmea(l)%ns_soil) )
-          ENDIF     
+             ALLOCATE( vmea(l)%depth(1:vmea(l)%ns_soil)  )
+          ENDIF
 !
 !--       For soil, store the grid indices.
@@ -885,8 +1300,8 @@
                             vmea(l)%j_soil(ns) = j
                             vmea(l)%k_soil(ns) = k
-                            vmea(l)%depth(ns)  = zs(k)
+                            vmea(l)%depth(ns)  = - zs(k)
                          ENDDO
                       ENDIF
-                      
+
                       IF ( surf_usm_h%start_index(j,i) <=                      &
                            surf_usm_h%end_index(j,i) )  THEN
@@ -897,5 +1312,5 @@
                             vmea(l)%j_soil(ns) = j
                             vmea(l)%k_soil(ns) = k
-                            vmea(l)%depth(ns)  = surf_usm_h%zw(k,m)
+                            vmea(l)%depth(ns)  = - surf_usm_h%zw(k,m)
                          ENDDO
                       ENDIF
@@ -907,5 +1322,5 @@
 !--       Allocate array to save the sampled values.
           ALLOCATE( vmea(l)%measured_vars(1:vmea(l)%ns,1:vmea(l)%nmeas) )
-          
+
           IF ( vmea(l)%soil_sampling )                                         &
              ALLOCATE( vmea(l)%measured_vars_soil(1:vmea(l)%ns_soil,           &
@@ -924,19 +1339,21 @@
           IF ( ALLOCATED( n_utm_tmp ) )  DEALLOCATE( n_utm_tmp )
           IF ( ALLOCATED( n_utm )     )  DEALLOCATE( n_utm )
-          IF ( ALLOCATED( z_ag  )     )  DEALLOCATE( z_ag  )
-          IF ( ALLOCATED( z_ag  )     )  DEALLOCATE( vmea(l)%dim_t )
+          IF ( ALLOCATED( zar  )      )  DEALLOCATE( vmea(l)%dim_t )
+          IF ( ALLOCATED( zar  )      )  DEALLOCATE( zar  )
+          IF ( ALLOCATED( station_h ) )  DEALLOCATE( station_h )
+
        ENDIF
     ENDDO
 !
-!-- Close input file for virtual measurements. Therefore, just call 
-!-- the read attribute routine with the "close" option. 
-    CALL netcdf_data_input_att( vmea_general%nvm, char_numstations,            &
-                                vmea_general%id_vm, '',                        &
-                                global_attribute, 'close', '' )
-!
-!-- Sum-up the number of observation coordiates, for atmosphere first. 
+!-- Dellocate flag array
+    DEALLOCATE( meas_flag )
+!
+!-- Close input file for virtual measurements. 
+    CALL close_input_file( pids_id )
+!
+!-- Sum-up the number of observation coordiates, for atmosphere first.
 !-- This is actually only required for data output.
     ALLOCATE( ns_all(1:vmea_general%nvm) )
-    ns_all = 0    
+    ns_all = 0
 #if defined( __parallel )
     CALL MPI_ALLREDUCE( vmea(:)%ns, ns_all(:), vmea_general%nvm, MPI_INTEGER,  &
@@ -948,5 +1365,5 @@
 !
 !-- Now for soil
-    ns_all = 0    
+    ns_all = 0
 #if defined( __parallel )
     CALL MPI_ALLREDUCE( vmea(:)%ns_soil, ns_all(:), vmea_general%nvm,          &
